"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var parse_commit_message_1 = require("parse-commit-message");
var ConventionalCommitsPlugin = /** @class */ (function () {
    function ConventionalCommitsPlugin() {
        this.name = 'Conventional Commits Parser';
    }
    ConventionalCommitsPlugin.prototype.apply = function (auto) {
        var _this = this;
        auto.hooks.onCreateLogParse.tap(this.name, function (logParse) {
            logParse.hooks.parseCommit.tap(_this.name, function (commit) {
                try {
                    var _a = __read(parse_commit_message_1.applyPlugins(parse_commit_message_1.mappers.increment, parse_commit_message_1.parse(commit.subject)), 1), conventionalCommit = _a[0];
                    if (conventionalCommit.header && conventionalCommit.increment) {
                        commit.labels = __spread(commit.labels, [
                            auto.semVerLabels.get(conventionalCommit.increment)
                        ]);
                    }
                }
                catch (error) {
                    auto.logger.verbose.info("No conventional commit message found for " + commit.hash);
                }
                return commit;
            });
        });
    };
    return ConventionalCommitsPlugin;
}());
exports.default = ConventionalCommitsPlugin;
//# sourceMappingURL=index.js.map